Index: pjproject/trunk/pjsip-apps/src/pjsua/bb10/.cproject
===================================================================
--- pjproject/trunk/pjsip-apps/src/pjsua/bb10/.cproject	(revision 4481)
+++ pjproject/trunk/pjsip-apps/src/pjsua/bb10/.cproject	(revision 4482)
@@ -53,5 +53,5 @@
 			</storageModule>
 			<storageModule moduleId="cdtBuildSystem" version="4.0.0">
-				<configuration artifactName="${ProjName}" buildProperties="" id="com.qnx.qcc.toolChain.2079401108" name="Device-Release" parent="org.eclipse.cdt.build.core.emptycfg">
+				<configuration artifactName="${ProjName}" buildProperties="" description="" id="com.qnx.qcc.toolChain.2079401108" name="Device-Release" parent="org.eclipse.cdt.build.core.emptycfg">
 					<folderInfo id="com.qnx.qcc.toolChain.2079401108.1026133684" name="/" resourcePath="">
 						<toolChain id="com.qnx.qcc.toolChain.1240537150" name="com.qnx.qcc.toolChain" superClass="com.qnx.qcc.toolChain">
@@ -61,7 +61,7 @@
 							<option id="com.qnx.qcc.option.runtime.1247073904" name="Runtime:" superClass="com.qnx.qcc.option.runtime"/>
 							<targetPlatform archList="all" binaryParser="com.qnx.tools.ide.qde.core.QDEBynaryParser" id="com.qnx.qcc.targetPlatform.1300126991" osList="all" superClass="com.qnx.qcc.targetPlatform"/>
-							<builder autoBuildTarget="Device-Release" enableAutoBuild="true" id="com.qnx.qcc.toolChain.2079401108.467426564" incrementalBuildTarget="Device-Release" managedBuildOn="false" name="Gnu Make Builder" parallelBuildOn="true" parallelizationNumber="optimal" superClass="org.eclipse.cdt.build.core.settings.default.builder"/>
+							<builder autoBuildTarget="Device-Release" enableAutoBuild="true" id="com.qnx.qcc.toolChain.2079401108.467426564" incrementalBuildTarget="Device-Release" keepEnvironmentInBuildfile="false" managedBuildOn="false" name="Gnu Make Builder" parallelBuildOn="true" parallelizationNumber="optimal" superClass="org.eclipse.cdt.build.core.settings.default.builder"/>
 							<tool id="com.qnx.qcc.tool.compiler.115320452" name="QCC Compiler" superClass="com.qnx.qcc.tool.compiler">
-								<option id="com.qnx.qcc.option.compiler.optlevel.77840692" superClass="com.qnx.qcc.option.compiler.optlevel" value="com.qnx.qcc.option.compiler.optlevel.0" valueType="enumerated"/>
+								<option id="com.qnx.qcc.option.compiler.optlevel.77840692" name="Optimization Level" superClass="com.qnx.qcc.option.compiler.optlevel" value="com.qnx.qcc.option.compiler.optlevel.0" valueType="enumerated"/>
 								<inputType id="com.qnx.qcc.inputType.compiler.153511514" superClass="com.qnx.qcc.inputType.compiler"/>
 							</tool>
@@ -178,3 +178,4 @@
 		<resource resourceType="PROJECT" workspacePath="/PjsuaBB"/>
 	</storageModule>
+	<storageModule moduleId="org.eclipse.cdt.internal.ui.text.commentOwnerProjectMappings"/>
 </cproject>
Index: pjproject/trunk/pjsip-apps/src/pjsua/bb10/.project
===================================================================
--- pjproject/trunk/pjsip-apps/src/pjsua/bb10/.project	(revision 4481)
+++ pjproject/trunk/pjsip-apps/src/pjsua/bb10/.project	(revision 4482)
@@ -4,9 +4,9 @@
 	<comment></comment>
 	<projects>
+		<project>pjproject</project>
 	</projects>
 	<buildSpec>
 		<buildCommand>
 			<name>org.eclipse.cdt.managedbuilder.core.genmakebuilder</name>
-			<triggers>clean,full,incremental,</triggers>
 			<arguments>
 				<dictionary>
@@ -20,5 +20,5 @@
 				<dictionary>
 					<key>org.eclipse.cdt.make.core.autoBuildTarget</key>
-					<value>Device-Debug</value>
+					<value>Device-Release</value>
 				</dictionary>
 				<dictionary>
@@ -40,5 +40,5 @@
 				<dictionary>
 					<key>org.eclipse.cdt.make.core.enableAutoBuild</key>
-					<value>false</value>
+					<value>true</value>
 				</dictionary>
 				<dictionary>
@@ -52,5 +52,5 @@
 				<dictionary>
 					<key>org.eclipse.cdt.make.core.fullBuildTarget</key>
-					<value>Device-Debug</value>
+					<value>Device-Release</value>
 				</dictionary>
 				<dictionary>
Index: pjproject/trunk/pjsip-apps/src/pjsua/bb10/src/applicationui.cpp
===================================================================
--- pjproject/trunk/pjsip-apps/src/pjsua/bb10/src/applicationui.cpp	(revision 4481)
+++ pjproject/trunk/pjsip-apps/src/pjsua/bb10/src/applicationui.cpp	(revision 4482)
@@ -66,11 +66,14 @@
 {
     // TODO: read from config?
-    char *argv[] = { (char*)"pjsuabb",
-		     (char*)"--use-cli",
-		     (char*)"--no-cli-console",
-		     (char*)"--cli-telnet-port=2323",
-		     (char*)"--dis-codec=*",
-		     (char*)"--add-codec=g722",
-		      NULL };
+    const char *argv[] = { "pjsuabb",
+			   "--use-cli",
+			   "--no-cli-console",
+			   "--cli-telnet-port=2323",
+			   "--no-vad",
+			   "--add-buddy=sip:169.254.0.2",
+			   "--quality=4",
+			   //(char*)"--dis-codec=*",
+			   //(char*)"--add-codec=g722",
+			    NULL };
     int argc = PJ_ARRAY_SIZE(argv) -1;
     pj_thread_desc thread_desc;
@@ -83,5 +86,5 @@
     on_started_cb = &bb10_telnet_started;
     on_quit_cb = &bb10_on_quit;
-    main_func(argc, argv);
+    main_func(argc, (char**)argv);
 }
 