Index: pjproject/trunk/pjsip-apps/src/pjsua/android/.project
===================================================================
--- pjproject/trunk/pjsip-apps/src/pjsua/android/.project	(revision 4525)
+++ pjproject/trunk/pjsip-apps/src/pjsua/android/.project	(revision 4526)
@@ -6,62 +6,4 @@
 	</projects>
 	<buildSpec>
-		<buildCommand>
-			<name>org.eclipse.cdt.managedbuilder.core.genmakebuilder</name>
-			<triggers>clean,full,incremental,</triggers>
-			<arguments>
-				<dictionary>
-					<key>?name?</key>
-					<value></value>
-				</dictionary>
-				<dictionary>
-					<key>org.eclipse.cdt.make.core.append_environment</key>
-					<value>true</value>
-				</dictionary>
-				<dictionary>
-					<key>org.eclipse.cdt.make.core.autoBuildTarget</key>
-					<value>all</value>
-				</dictionary>
-				<dictionary>
-					<key>org.eclipse.cdt.make.core.buildArguments</key>
-					<value></value>
-				</dictionary>
-				<dictionary>
-					<key>org.eclipse.cdt.make.core.buildCommand</key>
-					<value>make</value>
-				</dictionary>
-				<dictionary>
-					<key>org.eclipse.cdt.make.core.cleanBuildTarget</key>
-					<value>clean</value>
-				</dictionary>
-				<dictionary>
-					<key>org.eclipse.cdt.make.core.contents</key>
-					<value>org.eclipse.cdt.make.core.activeConfigSettings</value>
-				</dictionary>
-				<dictionary>
-					<key>org.eclipse.cdt.make.core.enableAutoBuild</key>
-					<value>false</value>
-				</dictionary>
-				<dictionary>
-					<key>org.eclipse.cdt.make.core.enableCleanBuild</key>
-					<value>true</value>
-				</dictionary>
-				<dictionary>
-					<key>org.eclipse.cdt.make.core.enableFullBuild</key>
-					<value>true</value>
-				</dictionary>
-				<dictionary>
-					<key>org.eclipse.cdt.make.core.fullBuildTarget</key>
-					<value>all</value>
-				</dictionary>
-				<dictionary>
-					<key>org.eclipse.cdt.make.core.stopOnError</key>
-					<value>true</value>
-				</dictionary>
-				<dictionary>
-					<key>org.eclipse.cdt.make.core.useDefaultBuildCmd</key>
-					<value>true</value>
-				</dictionary>
-			</arguments>
-		</buildCommand>
 		<buildCommand>
 			<name>com.android.ide.eclipse.adt.ResourceManagerBuilder</name>
@@ -84,18 +26,8 @@
 			</arguments>
 		</buildCommand>
-		<buildCommand>
-			<name>org.eclipse.cdt.managedbuilder.core.ScannerConfigBuilder</name>
-			<triggers>full,incremental,</triggers>
-			<arguments>
-			</arguments>
-		</buildCommand>
 	</buildSpec>
 	<natures>
 		<nature>com.android.ide.eclipse.adt.AndroidNature</nature>
 		<nature>org.eclipse.jdt.core.javanature</nature>
-		<nature>org.eclipse.cdt.core.cnature</nature>
-		<nature>org.eclipse.cdt.core.ccnature</nature>
-		<nature>org.eclipse.cdt.managedbuilder.core.managedBuildNature</nature>
-		<nature>org.eclipse.cdt.managedbuilder.core.ScannerConfigNature</nature>
 	</natures>
 </projectDescription>
Index: pjproject/trunk/pjsip-apps/src/pjsua/android/jni/Android.mk
===================================================================
--- pjproject/trunk/pjsip-apps/src/pjsua/android/jni/Android.mk	(revision 4525)
+++ pjproject/trunk/pjsip-apps/src/pjsua/android/jni/Android.mk	(revision 4526)
@@ -1,3 +1,3 @@
-# $id$
+# $Id$
 
 LOCAL_PATH	:= $(call my-dir)
@@ -11,33 +11,10 @@
 MY_SWIG		:= swig
 
-#========================================================================
-# Choose console application to load
-#========================================================================
-
-# pjlib test
-#MY_MODULE :=  $(PJDIR)/pjlib/build/output/pjlib-test-$(TARGET_NAME)/*.o
-
-# pjlib-util test
-#MY_MODULE :=  $(PJDIR)/pjlib-util/build/output/pjlib-util-test-$(TARGET_NAME)/*.o
-
-# pjsip test
-#MY_MODULE :=  $(PJDIR)/pjsip/build/output/pjsip-test-$(TARGET_NAME)/*.o
-
-# pjnath test
-#MY_MODULE :=  $(PJDIR)/pjnath/build/output/pjnath-test-$(TARGET_NAME)/*.o
-
-# pjmedia test
-# Note: jbuf test requires Jbtest.dat, this jbuf test must be disabled (for now).
-#MY_MODULE :=  $(PJDIR)/pjmedia/build/output/pjmedia-test-$(TARGET_NAME)/*.o
-
-# pjsystest app (not supported yet)
-# Todo: this test requires some input and output files (log & WAV).
-#MY_MODULE := $(PJDIR)/pjsip-apps/build/output/pjsystest-$(TARGET_NAME)/*.o
-
-# pjsua app
-# Note: must set USE_GUI to zero in config_site.h
-MY_MODULE := $(PJDIR)/pjsip-apps/build/output/pjsua-$(TARGET_NAME)/*.o
-
-#========================================================================
+MY_MODULE_PATH  := $(PJDIR)/pjsip-apps/build/output/pjsua-$(TARGET_NAME)
+MY_MODULES      := $(MY_MODULE_PATH)/pjsua_app.o \
+		   $(MY_MODULE_PATH)/pjsua_app_cli.o \
+		   $(MY_MODULE_PATH)/pjsua_app_common.o \
+		   $(MY_MODULE_PATH)/pjsua_app_config.o \
+		   $(MY_MODULE_PATH)/pjsua_app_legacy.o
 
 # Constants
@@ -49,5 +26,5 @@
 LOCAL_CFLAGS    := -Werror $(APP_CFLAGS) -frtti
 LOCAL_LDFLAGS   := $(APP_LDFLAGS)
-LOCAL_LDLIBS    := $(MY_MODULE) $(APP_LDLIBS)
+LOCAL_LDLIBS    := $(MY_MODULES) $(APP_LDLIBS)
 LOCAL_SRC_FILES := $(MY_JNI_WRAP) pjsua_app_callback.cpp
 